
/* найти узлы с текстом */
	/* найти все узлы */
	/* рекурсивно проверять всех потомков */
	/* при нахождении текстового узла */
		/* сохранить узел в массиве */

/*
объектная модель:

textNodeList = [
	textNode, ...
];

foundPinYinByNode = [
	{
		textNode: textNode1,
		found: {
			start1: matchedString,
			start2: matchedString, 
			...
		},
	},
	{
		textNode: textNode2,
		found: ...
	}
]
*/

var textNodeList = [];
var foundPinYinByNode = [];

// при загрузке dom
$(function () {
	connectStylesheet();
	textNodeList = searchForTextNodeIn($('body').get(0));

	var textNodeListLength = textNodeList.length;
	for (var i = 0; i < textNodeListLength; ++i) {
		textNode = textNodeList[i];

		var found = searchForPinYinInString(textNode.textContent);
		// searchForHanZiNearPinYin()
		if (Object.keys(found).length == 0) {
			continue;
		};
		foundPinYinByNode.push({textNode: textNode, found: found});
		// расскраска
		colorizePinYin(textNode, found);
	};
});


function searchForTextNodeIn (node, result) {
	result = result || [];
	var childs = node.childNodes;
	if (childs.length == 0) {return;};

	var childsLength = childs.length;
	for (var i = 0; i < childsLength; ++i) {
		var childNode = childs[i];

		if (childNode.nodeType == 1 /*ELEMENT_NODE*/) {
			/* исключить скрипты и стили */
			tagName = childNode.tagName.toLowerCase();
			if (tagName === 'script' ||
				tagName === 'style') {
				continue;
			};
			searchForTextNodeIn(childNode, result);
		} else if (childNode.nodeType == 3 /*TEXT_NODE*/) {
			/* сразу убрать пустые строки */
			if (childNode.textContent.match(/^\s*$/) != null) {
				continue;
			};
			result.push(childNode);
		};
	};
	return result;
};


// объявить список раньше функции, чтобы избежать многократного разбора
var allPinYinList = ['zhuang','shuang','chuang','zhuan','zhuai','zhong','zheng','zhang','xiong','xiang','shuan','shuai','sheng','shang','qiong','qiang','niang','liang','kuang','jiong','jiang','huang','guang','chuan','chuai','chong','cheng','chang','zuan','zong','zhuo','zhun','zhui','zhua','zhou','zhen','zhei','zhao','zhan','zhai','zeng','zang','yuan','yong','ying','yang','xuan','xing','xiao','xian','weng','wang','tuan','tong','ting','tiao','tian','teng','tang','suan','song','shuo','shun','shui','shua','shou','shen','shei','shao','shan','shai','seng','sang','ruan','rong','reng','rang','quan','qing','qiao','qian','ping','piao','pian','peng','pang','nüe','nuan','nong','ning','niao','nian','neng','nang','ming','miao','mian','meng','mang','lüe','luan','long','ling','liao','lian','leng','lang','kuan','kuai','kong','keng','kang','juan','jing','jiao','jian','huan','huai','hong','heng','hang','guan','guai','gong','geng','gang','feng','fang','duan','dong','ding','diao','dian','deng','dang','cuan','cong','chuo','chun','chui','chua','chou','chen','chao','chan','chai','ceng','cang','bing','biao','bian','beng','bang','zuo','zun','zui','zou','zhu','zhi','zhe','zha','zen','zei','zao','zan','zai','yun','yue','you','yin','yao','yan','xun','xue','xiu','xin','xie','xia','wen','wei','wan','wai','tuo','tun','tui','tou','tie','tao','tan','tai','suo','sun','sui','sou','shu','shi','she','sha','sen','sei','sao','san','sai','ruo','run','rui','rua','rou','ren','rao','ran','qun','que','qiu','qin','qie','qia','pou','pin','pie','pen','pei','pao','pan','pai','nü','nuo','nou','niu','nin','nie','nen','nei','nao','nan','nai','mou','miu','min','mie','men','mei','mao','man','mai','lü','luo','lun','lou','liu','lin','lie','lia','lei','lao','lan','lai','kuo','kun','kui','kua','kou','ken','kei','kao','kan','kai','jun','jue','jiu','jin','jie','jia','huo','hun','hui','hua','hou','hng','hen','hei','hao','han','hai','guo','gun','gui','gua','gou','gen','gei','gao','gan','gai','fou','fen','fei','fan','duo','dun','dui','dou','diu','die','den','dei','dao','dan','dai','cuo','cun','cui','cou','chu','chi','che','cha','cen','cei','cao','can','cai','bin','bie','ben','bei','bao','ban','bai','ang','ê','zu','zi','ze','za','yu','yi','ye','ya','xu','xi','wu','wo','wa','tu','ti','te','ta','su','si','se','sa','ru','ri','re','qu','qi','pu','po','pi','pa','ou','nu','ni','ng','ne','na','mu','mo','mi','ma','lu','li','le','la','ku','ke','ka','ju','ji','hu','hm','he','ha','gu','ge','ga','fu','fo','fa','er','en','ei','du','di','de','da','cu','ci','ce','ca','bu','bo','bi','ba','ao','an','ai','o','n','m','e','a','r'];
var allPinYinListLength = allPinYinList.length;

function searchForPinYinInString (pinYin) {
	var result = {};

  /*if (typeof pinYin !== 'string') {
		throw new Error('splitPinYin: argument is not a string');
	};*/
	
	// заменить тона в пиньинь для поиска
	var py_plain = pinYin.toLowerCase()
	.replace(/[āáǎăà]/g, 'a').replace(/[ēéěè]/g, 'e')
	.replace(/[ōóǒò]/g, 'o').replace(/[ūúǔù]/g, 'u')
	.replace(/[ǖǘǚǜ]/g, 'u').replace(/[īíǐì]/g, 'i');

	var py_plainLength = py_plain.length;
	for (var charP = 0; charP < py_plainLength; /* сдвиг счётчика вручную */ ) {
		var ch = py_plain.charCodeAt(charP);
		if (ch < 97 /*'a'.charCodeAt()*/ || ch > 122/*'z'*/) {
			++charP;
			continue;
		};

		var found = null;
		for (var i = 0, e = ''; i < allPinYinListLength; ++i) {
			e = allPinYinList[i];
			if (py_plain.indexOf(e, charP) == charP) {
				found = e;
				break;
			};
		}; // for

		if (found) {
			// сохранить 'found' потомкам, для гордости
			result[new Number(charP)] = pinYin.slice(
						charP, charP+found.length
					);
			charP += found.length;

		} else {
			// пропустить всё до ближайшего пробела
			var spaceRE = /\s+/;
			while (charP < py_plainLength &&
				   ! py_plain[charP].match(spaceRE)) {
				++charP;
			};
			// а заодно и все пробелы
			while (charP < py_plainLength &&
				   py_plain[charP].match(spaceRE)) {
				++charP;
			};
		}
	} // for
	return result;
}; // searchForPinYinInString


// объявить заранее
var toneLabledLatinsTable = [
		null,      // [0]
		'āēūǖīō',  // [1]
		'áéúǘíó',  // [2]
		'ǎăěǔǚǐǒ', // [3]
		'àèùǜìò'   // [4]
	];
function determineTone (pinYinWord) {
	// для каждого тона
	for (var tone = 1; tone <= 4; ++tone) {
		toneStr = toneLabledLatinsTable[tone];
		for (var l = toneStr.length; l >= 0; --l) {
			if (pinYinWord.indexOf(toneStr[l]) != -1) {
				return tone;
			};
		};
	};
	return 0; // нулевой тон
};


function colorizePinYin (onNode, pinYinPairs) {

	var pinYinSpan = document.createElement('span');
	pinYinSpan.classList.add('pinYinWrapper');

	var prevPair = null;

	for (start in pinYinPairs) {
		start = new Number(start);
		// записать предшествующий не-пиньинь в родительский span
		// xss leak!
		pinYinSpan.innerHTML += onNode.textContent.slice(
			(prevPair != null) ? (prevPair.start + prevPair.length) : 0,
			start
			);

		var tone = determineTone (pinYinPairs[start]);
		
		var span = document.createElement('span');

		span.classList.add('t'+tone);
		span.innerHTML = pinYinPairs[start];

		pinYinSpan.appendChild(span);

		prevPair = {start: start, length: pinYinPairs[start].length};
	};
	// finaly
	pinYinSpan.innerHTML += onNode.textContent.slice(prevPair.start + prevPair.length);

	var p = onNode.parentNode;
	p.insertBefore(pinYinSpan, onNode);
	p.removeChild(onNode);
}; // colorizePinYin


function connectStylesheet () {
	var styleTagId = 'ColorizeStyleID';

	if (!document.getElementById(styleTagId)) {
		var styleNode = document.createElement('style');
		styleNode.id = styleTagId;
		styleNode.type='text/css';
		styleNode.textContent = '.t0 {color: #000;} .t1 {color: #F8C142;} .t2 {color: #66CD3B;} .t3 {color: #205CB5;} .t4 {color: #ED3F27;} .t1, .t2, .t3, .t4 {_text-shadow: 1px 1px 1px rgba(0, 0, 0, .5);}';
		document.getElementsByTagName('head')[0].appendChild(styleNode);
	};	
};
